.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include SendingMail.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		; -- Get handles for my widgets --
		invoke	GetDlgItem, hWnd, IDC_SEND
		mov		hButton, eax
		
		; -- Load my DLL Procedures --
		invoke	LoadLibrary, offset MapiDLLStr
		mov		hMAPI, eax
		invoke	GetProcAddress, hMAPI, offset MapiSndStr
		mov		dll_MAILSEND, eax
		
		invoke	RtlZeroMemory, addr MMessage, sizeof MMessage			; create a memory structure for the message
		invoke	RtlZeroMemory, addr MRecipnt, sizeof MRecipnt			; cteate a memory structure for the recipient
		
		; Put some value into the message array.
		mov		MMessage.lpszSubject, offset mSubject
		mov		MMessage.lpszNoteText, offset MapiBody
		mov		MMessage.lpRecips, offset MRecipnt
		
		; Put some values into the recipint array
		mov		MRecipnt.lpszAddress, offset MapiTo
		mov		MRecipnt.lpszName, offset MapiName
		mov		MRecipnt.ulRecipClass, MAPI_TO
		
		

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_SEND
		; call for the DLL procedure...
		
		push	NULL								; Reserved
		push 	MAPI_DIALOG or MAPI_LOGON_UI		; ulFlags
		push 	offset MMessage				 		; MAPI Strucrture of email message.
		push	NULL								; ulParam
		push	NULL								; MAPI Session
		call	dll_MAILSEND						; Call for external procedure
		
		
		.if (eax == SUCCESS_SUCCESS)
			invoke	MessageBox, hWnd, addr MailErr, addr mSubject, MB_OK 
		.endif
		
		push 	eax							; save the content of eax
		invoke	FreeLibrary, hMAPI			; free off the library that I don't need
		pop		eax 						; recover eax
		.endif

	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
